/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton interface for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ACT_ACCEPT = 258,
     ACT_REJECT = 259,
     ACT_TEMPFAIL = 260,
     ACT_CONTINUE = 261,
     ACT_DISCARD = 262,
     ADD = 263,
     REPLACE = 264,
     DELETE = 265,
     PROG = 266,
     IF = 267,
     FI = 268,
     ELSE = 269,
     ELIF = 270,
     ON = 271,
     HOST = 272,
     FOR = 273,
     FROM = 274,
     AS = 275,
     DO = 276,
     DONE = 277,
     POLL = 278,
     MATCHES = 279,
     FNMATCHES = 280,
     MXMATCHES = 281,
     MXFNMATCHES = 282,
     WHEN = 283,
     NEXT = 284,
     SET = 285,
     CATCH = 286,
     KW_ECHO = 287,
     RETURNS = 288,
     RETURN = 289,
     FUNC = 290,
     SWITCH = 291,
     CASE = 292,
     DEFAULT = 293,
     STRING = 294,
     CODE = 295,
     XCODE = 296,
     SYMBOL = 297,
     VARIABLE = 298,
     IDENTIFIER = 299,
     ARG = 300,
     NUMBER = 301,
     BACKREF = 302,
     BUILTIN = 303,
     OR = 304,
     AND = 305,
     EQ = 306,
     NE = 307,
     LT = 308,
     LE = 309,
     GT = 310,
     GE = 311,
     NOT = 312,
     FUNCTION = 313,
     PROCEDURE = 314,
     TYPE = 315,
     UMINUS = 316
   };
#endif
/* Tokens.  */
#define ACT_ACCEPT 258
#define ACT_REJECT 259
#define ACT_TEMPFAIL 260
#define ACT_CONTINUE 261
#define ACT_DISCARD 262
#define ADD 263
#define REPLACE 264
#define DELETE 265
#define PROG 266
#define IF 267
#define FI 268
#define ELSE 269
#define ELIF 270
#define ON 271
#define HOST 272
#define FOR 273
#define FROM 274
#define AS 275
#define DO 276
#define DONE 277
#define POLL 278
#define MATCHES 279
#define FNMATCHES 280
#define MXMATCHES 281
#define MXFNMATCHES 282
#define WHEN 283
#define NEXT 284
#define SET 285
#define CATCH 286
#define KW_ECHO 287
#define RETURNS 288
#define RETURN 289
#define FUNC 290
#define SWITCH 291
#define CASE 292
#define DEFAULT 293
#define STRING 294
#define CODE 295
#define XCODE 296
#define SYMBOL 297
#define VARIABLE 298
#define IDENTIFIER 299
#define ARG 300
#define NUMBER 301
#define BACKREF 302
#define BUILTIN 303
#define OR 304
#define AND 305
#define EQ 306
#define NE 307
#define LT 308
#define LE 309
#define GT 310
#define GE 311
#define NOT 312
#define FUNCTION 313
#define PROCEDURE 314
#define TYPE 315
#define UMINUS 316




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
#line 202 "gram.y"
{
	char *string;
	struct {
		NODE *head;
 		NODE *tail;
	} stmtlist;
	NODE *node;
	struct return_node ret;
	struct poll_data poll;
	struct locus locus;
	struct pollarg {
		int kw;
		NODE *expr;
	} pollarg;
	struct arglist {
		NODE *head;
		NODE *tail;
		size_t count;
	} arglist;
	long number;
	const struct builtin *builtin;
	struct variable *var;
	enum smtp_state state;
	struct {
		struct locus locus;
		int qualifier;
	} matchtype;
	data_type_t type;
	struct parmtype *parm;
	struct parmlist {
		struct parmtype *head, *tail;
		int count;
	} parmlist;
	int tie_in;
	struct function *function;
	struct {
		struct valist *head, *tail;
	} valist_list;
	struct valist *valist;
	struct {
		struct case_stmt *head, *tail;
	} case_list ;
	struct case_stmt *case_stmt;
}
/* Line 1529 of yacc.c.  */
#line 216 "gram.h"
	YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif

extern YYSTYPE yylval;

